<?php
/*
* 2007-2014 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Open Software License (OSL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/osl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2014 PrestaShop SA
*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

class TntAccountService extends ObjectModel
{
	public $id_tnt_account;
        
        public $groupBox;

	/**
	 * @see ObjectModel::$definition
	 */
	public static $definition = array(
		'table' => 'tnt_account_service',
		'primary' => 'id_tnt_account_service',
		'fields' => array(
			'id_tnt_account' => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId', 'required' => true),
                ),
	);
        
	/**
	 * Build an address
	 *
	 * @param integer $id_address Existing address id in order to load object (optional)
	 */
	public	function __construct()
	{
		parent::__construct();
	}        
        
        
 	public function add($autodate = true, $null_values = false)
	{
		$this->updateService($this->groupBox);
                // TODO: Qué debe retornar? parent::add($autodate, $null_values)?
		return true;
	}       

	/**
	 * Update customer groups associated to the object
	 *
	 * @param array $list groups
	 */
	public function updateService($list)
	{
		if ($list && !empty($list))
		{
			$this->cleanServices();
			$this->addServices($list);     
		}
	}

	public function cleanServices()
	{
		Db::getInstance()->execute('DELETE FROM `'._DB_PREFIX_.'tnt_account_service` WHERE `id_tnt_account` = '.(int)$this->id_tnt_account);
	}

	public function addServices($options)
	{
		foreach ($options as $option)
		{
			$row = array('id_tnt_account' => (int)$this->id_tnt_account, 
                                     'id_tnt_service' => (int)$option);
                        Db::getInstance()->insert('tnt_account_service', $row, false, true, Db::INSERT_IGNORE);
		}
	}
        
        public static function getServiceById($id_service) {
            /*
             * TO DO
             */
    }        
      public function getServiceById($id_service){
          $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS(
                '
                    select *
                    FROM `' . _DB_PREFIX_ . 'tnt_service` serv
                        where serv.id_tnt_service= ' . $id_service. '
'
        );

        if (!$result) {
            return false;
        }
        return $result;
          
      }
}
