<?php

/*
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author PrestaShop SA <contact@prestashop.com>
 *  @copyright  2007-2014 PrestaShop SA
 *  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */

include_once 'TntConnect.php';

class TntOption extends ObjectModel {

    public $name;
    public $loginuser;
    public $password;
    public $account;

    /** @var bool active state */
    public $active;

    /**
     * @see ObjectModel::$definition
     */
    public static $definition = array(
        'table' => 'tnt_option',
        'primary' => 'id_tnt_option',
        'fields' => array(
            'option_code' => array('type' => self::TYPE_STRING, 'validate' => 'isGenericName', 'required' => true, 'size' => 5),
            'description' => array('type' => self::TYPE_STRING, 'validate' => 'isGenericName', 'required' => true, 'size' => 100),
        ),
    );

    public static function getTntOption() {


        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
		SELECT ta.*
		FROM `' . _DB_PREFIX_ . 'tnt_option` ta 
		');

        if (!$result) {
            return false;
        }
        return $result;
    }

    public static function getTntOptionById($id_tnt_option) {


        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
		SELECT ta.*
		FROM `' . _DB_PREFIX_ . 'tnt_option` ta 
                    where id_tnt_option = ' . $id_tnt_option . '
		');

        if (!$result) {
            return false;
        }
        return $result;
    }

    public static function getTntOptionByServiceId($id_service) {
        $query = '
		SELECT ta.*
		FROM `' . _DB_PREFIX_ . 'tnt_option` ta 
                    inner join `' . _DB_PREFIX_ . 'tnt_rela_service_option` rela on rela.id_tnt_option = ta.id_tnt_option 
                    where rela.id_tnt_service = ' . $id_service . '
		';

        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($query);

        if (!$result) {
            return false;
        }
        return $result;
    }

}
