<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class TntRecogidaLabel extends ObjectModel {

    public static $definition = array(
        'table' => 'tnt_recogida_label',
        'primary' => 'id_tnt_recogida_label',
        'fields' => array(
            'id_order' => array('type' => self::TYPE_INT, 'required' => true, 'size' => 10),
            'id_tnt_service' => array('type' => self::TYPE_INT, 'required' => true, 'size' => 10),
            'total_package' => array('type' => self::TYPE_INT, 'required' => true, 'size' => 4),
            'total_weight' => array('type' => self::TYPE_INT, 'required' => true, 'size' => 4),
            'total_volume' => array('type' => self::TYPE_INT, 'required' => true, 'size' => 4),
            'id_tnt_account_address' => array('type' => self::TYPE_INT, 'required' => true, 'size' => 10),
            'instruccion_recogida' => array('type' => self::TYPE_STRING, 'required' => false, 'size' => 254),
            'reference' => array('type' => self::TYPE_STRING, 'required' => false, 'size' => 10),
            'connumber' => array('type' => self::TYPE_STRING, 'required' => false, 'size' => 20),
            'group_code' => array('type' => self::TYPE_STRING, 'required' => true, 'size' => 40),
            'date_create' => array('type' => self::TYPE_DATE, 'required' => true,),
            'manifested' => array('type' => self::TYPE_DATE, 'required' => false),
            'booked' => array('type' => self::TYPE_DATE, 'required' => false),
            'tnt_recogida_label_result' => array('type' => self::TYPE_STRING, 'required' => true),
        ),
    );

    public function create($id_order, $id_tnt_service, $id_tnt_account_address, $reference, $cunnumber, $group_code, $label, $connote, $total_package, $total_weight, $total_volume, $instruccion_recogida) {

        $label = (string) base64_encode($label);
        $connote = (string) base64_encode($connote);
        $insertData = array(
            'id_order' => $id_order,
            'id_tnt_service' => $id_tnt_service,
            'id_tnt_account_address' => $id_tnt_account_address,
            'reference' => $reference,
            'connumber' => $cunnumber,
            'group_code' => $group_code,
            'tnt_recogida_label_result' => $label,
            'tnt_recogida_connote_result' => $connote,
            'date_create' => date('Y-m-d'),
            'total_package' => $total_package,
            'total_weight' => $total_weight,
            'total_volume' => $total_volume,
            'instruccion_recogida' => $instruccion_recogida,
        );

        Db::getInstance()->insert('tnt_recogida_label', $insertData);
        return true;
    }

    public function getLastActive($id_address) {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
		SELECT *
		FROM `" . _DB_PREFIX_ . "tnt_recogida_label` 
		WHERE
                date_create = '" . date('Y-m-d') . "'
                and id_tnt_account_address = '" . $id_address . "'
                and manifested is null
                
                    
		");

        if (!$result) {
            return false;
        }
        return $result[0];
    }

    public function getActiveManifest() {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
		SELECT *,count(reco.id_order) as total
		FROM `" . _DB_PREFIX_ . "tnt_recogida_label` as reco
                inner join `" . _DB_PREFIX_ . "tnt_account_address` acco on acco.id_tnt_account_address = reco.id_tnt_account_address
		WHERE
                manifested is null
                group by reco.group_code
                    
		");

        if (!$result) {
            return false;
        }
        return $result;
    }

    public function getOldManifest($filter_group_code = null, $filter_direccion_recogida = null, $filter_cod_postal = null, $filter_ciudad = null, $manifest_date_ini = null, $manifest_date_end = null) {
        if ($manifest_date_ini) {
            $day = substr($manifest_date_ini, 0, 2);
            $month = substr($manifest_date_ini, 3, 2);
            $year = substr($manifest_date_ini, -4);
            $manifest_date_ini = $year . '-' . $month . '-' . $day;
        }
        if ($manifest_date_end) {
            $day = substr($manifest_date_end, 0, 2);
            $month = substr($manifest_date_end, 3, 2);
            $year = substr($manifest_date_end, -4);
            $manifest_date_end = $year . '-' . $month . '-' . $day;
        }


        $query = "
		SELECT *,count(reco.id_order) as total
		FROM `" . _DB_PREFIX_ . "tnt_recogida_label` as reco
                inner join `" . _DB_PREFIX_ . "tnt_account_address` acco on acco.id_tnt_account_address = reco.id_tnt_account_address
		WHERE
                manifested is not null
                " . ($manifest_date_ini && $manifest_date_end ? " and reco.manifested between '" . $manifest_date_ini . "' and '" . $manifest_date_end . "'" : "") . "
                " . ($filter_group_code ? " and reco.group_code like '%" . $filter_group_code . "%'" : '') . "    
                group by reco.group_code
                    
		";

        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($query);

        if (!$result) {
            return false;
        }
        return $result;
    }

    public function updateManifestOrder($group_code) {
        $data = array(
            'manifested' => date('Y-m-d')
        );
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->update('tnt_recogida_label', $data, "group_code = '" . $group_code . "'");
    }

    public function updateBookedOrder($id_order, $booking_ref) {
        $data = array(
            'booked' => $booking_ref,
        );
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->update('tnt_recogida_label', $data, "id_order = '" . $id_order . "'");
    }

    public function getOrderByGroupCode($group_code) {
        $query = "
            select
            rec_lab.id_order,
            rec_lab.connumber,
            serv.code,
            serv.description,
            sta.name,
            tnt_acc.id_tnt_account,
            sta_tnt.name as collect_state_name,
            ctr_tnt.iso_code as collect_iso_code,
            ctr.iso_code,
            ord.id_order,
            ord.reference,
            ord.total_paid,
            adr.firstname,
            adr.lastname,
            cus.email,
            adr.address1,
            adr.address2,   
            rec_lab.instruccion_recogida,
            adr.postcode,
            adr.city,
            adr.phone,
            rec_lab.total_weight,
            rec_lab.total_volume,
            tnt_acc_add.address_1 as collect_addres_1,
            tnt_acc_add.address_2 as collect_addres_2,
            tnt_acc_add.address_3 as collect_addres_3,
            tnt_acc_add.postcode as collect_postcode,
            tnt_acc_add.city as collect_city,
            rec_lab.total_package,
            (select count(id_order_detail) from `" . _DB_PREFIX_ . "order_detail` where id_order = rec_lab.id_order) as total_item
            from `" . _DB_PREFIX_ . "tnt_recogida_label` as rec_lab
            inner join `" . _DB_PREFIX_ . "tnt_account_address` tnt_acc_add on tnt_acc_add.id_tnt_account_address = rec_lab.id_tnt_account_address
            
            left join `" . _DB_PREFIX_ . "country` ctr_tnt on ctr_tnt.id_country = tnt_acc_add.id_country
            left join `" . _DB_PREFIX_ . "state` sta_tnt on sta_tnt.id_country = ctr_tnt.id_country and sta_tnt.id_state = tnt_acc_add.id_state
                
            inner join `" . _DB_PREFIX_ . "tnt_account` tnt_acc on tnt_acc_add.id_tnt_account= tnt_acc.id_tnt_account
            inner join `" . _DB_PREFIX_ . "tnt_service` serv on serv.id_tnt_service = rec_lab.id_tnt_service
            inner join `" . _DB_PREFIX_ . "orders` ord on ord.id_order = rec_lab.id_order
            inner join `" . _DB_PREFIX_ . "customer` cus on  ord.id_customer = cus.id_customer
            inner join `" . _DB_PREFIX_ . "address` adr on ord.id_address_delivery = adr.id_address
            left join `" . _DB_PREFIX_ . "country` ctr on ctr.id_country = adr.id_country
            left join `" . _DB_PREFIX_ . "state` sta on sta.id_country = ctr.id_country and sta.id_state = adr.id_state
            where rec_lab.group_code = '" . $group_code . "'
        ";
        
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($query);




        if (!$result) {
            return false;
        }
        return $result;
    }

    public static function getDetailOrderById($id_order) {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
            select
            *,ctr.iso_code as order_country
            from `" . _DB_PREFIX_ . "order_detail` as rec_lab
            inner join `" . _DB_PREFIX_ . "orders` ord on ord.id_order = rec_lab.id_order
            inner join `" . _DB_PREFIX_ . "customer` cus on  ord.id_customer = cus.id_customer
            inner join `" . _DB_PREFIX_ . "address` adr on ord.id_address_delivery = adr.id_address
            left join `" . _DB_PREFIX_ . "country` ctr on ctr.id_country = adr.id_country
            left join `" . _DB_PREFIX_ . "state` sta on sta.id_country = ctr.id_country and sta.id_state = adr.id_state
            where rec_lab.id_order= '" . $id_order . "'
        ");




        if (!$result) {
            return false;
        }
        return $result[0];
    }

    public static function getOrderForPriceById($id_order) {
        $query = "select "
                . "rec_lab.id_order,"
                . "rec_lab.total_weight, "
                . "rec_lab.total_package, "
                . "rec_lab.total_volume,"
                . "rec_lab.total_volume,"
                . "tnt_acc_add.postcode as sender_postcode,"
                . "ctr.iso_code as sender_country, "
                . "tnt_acc_add.city as sender_state, "
                . "adr.postcode as receiver_postcode ,"
                . "ps_ctr.iso_code as receiver_country ,"
                . "adr.city as receiver_state, "
                . "tnt_acc_acc.loginuser, "
                . "tnt_acc_acc.account ,"
                . "tnt_service.* ,"
                . "tnt_acc_acc.password "
                . "from `" . _DB_PREFIX_ . "tnt_recogida_label` as rec_lab "
                . "inner join `" . _DB_PREFIX_ . "tnt_service` tnt_service on rec_lab.id_tnt_service = tnt_service.id_tnt_service "
                . "inner join `" . _DB_PREFIX_ . "tnt_account_address` tnt_acc_add on tnt_acc_add.id_tnt_account_address = rec_lab.id_tnt_account_address "
                . "inner join `" . _DB_PREFIX_ . "tnt_account` tnt_acc_acc on tnt_acc_acc.id_tnt_account = tnt_acc_add.id_tnt_account "
                . "left join `" . _DB_PREFIX_ . "country` ctr on ctr.id_country = tnt_acc_add.id_country "
                . "left join `" . _DB_PREFIX_ . "state` sta on sta.id_country = ctr.id_country and sta.id_state = tnt_acc_add.id_state "
                . "inner join `" . _DB_PREFIX_ . "orders` ps_order on ps_order.id_order = rec_lab.id_order "
                . "inner join `" . _DB_PREFIX_ . "address` adr on ps_order.id_address_delivery = adr.id_address "
                . "left join `" . _DB_PREFIX_ . "country` ps_ctr on ps_ctr.id_country = adr.id_country "
                . "left join `" . _DB_PREFIX_ . "state` ps_sta on ps_sta.id_country = ps_ctr.id_country and ps_sta.id_state = adr.id_state "
                . "where rec_lab.id_order = '" . $id_order . "'";

        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($query);
        if (!$result) {
            return false;
        }
        return $result;
    }

    public static function getOrderById($id_order) {
        $query = "
            select
            rec_lab.id_order,
            rec_lab.connumber,
            tnt_acc.id_tnt_account,
            serv.code,
            serv.description,
            sta.name,
            sta_tnt.name as collect_state_name,
            ctr.iso_code,
            ctr_tnt.iso_code as collect_iso_code,
            ord.id_order,
            ord.reference,
            ord.total_paid,
            adr.firstname,
            adr.lastname,
            cus.email,
            adr.address1,
            adr.address2,
            adr.postcode,
            adr.city,
            adr.phone,
            rec_lab.instruccion_recogida,
            rec_lab.total_weight,
            rec_lab.total_volume,
            rec_lab.total_package,
            tnt_acc_add.address_1 as collect_addres_1,
            tnt_acc_add.address_2 as collect_addres_2,
            tnt_acc_add.address_3 as collect_addres_3,
            tnt_acc_add.postcode as collect_postcode,
            tnt_acc_add.city as collect_city,
            (select count(id_order_detail) from `" . _DB_PREFIX_ . "order_detail` where id_order = rec_lab.id_order) as total_item
            from `" . _DB_PREFIX_ . "tnt_recogida_label` as rec_lab
            inner join `" . _DB_PREFIX_ . "tnt_account_address` tnt_acc_add on tnt_acc_add.id_tnt_account_address = rec_lab.id_tnt_account_address
            left join `" . _DB_PREFIX_ . "country` ctr_tnt on ctr_tnt.id_country = tnt_acc_add.id_country
            left join `" . _DB_PREFIX_ . "state` sta_tnt on sta_tnt.id_country = ctr_tnt.id_country and sta_tnt.id_state = tnt_acc_add.id_state
            inner join `" . _DB_PREFIX_ . "tnt_account` tnt_acc on tnt_acc_add.id_tnt_account= tnt_acc.id_tnt_account
            inner join `" . _DB_PREFIX_ . "tnt_service` serv on serv.id_tnt_service = rec_lab.id_tnt_service
            inner join `" . _DB_PREFIX_ . "orders` ord on ord.id_order = rec_lab.id_order
            inner join `" . _DB_PREFIX_ . "customer` cus on  ord.id_customer = cus.id_customer
            inner join `" . _DB_PREFIX_ . "address` adr on ord.id_address_delivery = adr.id_address
            left join `" . _DB_PREFIX_ . "country` ctr on ctr.id_country = adr.id_country
            left join `" . _DB_PREFIX_ . "state` sta on sta.id_country = ctr.id_country and sta.id_state = adr.id_state
            where rec_lab.id_order= '" . $id_order . "'
        ";
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($query);




        if (!$result) {
            return false;
        }
        return $result;
    }

    public function getLabel($id_order) {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
            select tnt_recogida_label_result from `" . _DB_PREFIX_ . "tnt_recogida_label`
            where id_order = '" . $id_order . "'
        ");
        if (!$result) {
            return false;
        }
        return $result;
    }

    public function getConnote($id_order) {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
            select tnt_recogida_connote_result from `" . _DB_PREFIX_ . "tnt_recogida_label`
            where id_order = '" . $id_order . "'
        ");
        if (!$result) {
            return false;
        }
        return $result;
    }

    public function getBooking() {

        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
            select reco.group_code, sum(reco.total_weight) as total_weight, acco.address_1, acco.address_2, acco.address_3, acco.city, acco.postcode,reco.id_tnt_account_address
            from `" . _DB_PREFIX_ . "tnt_recogida_label` as reco
            inner join `" . _DB_PREFIX_ . "tnt_account_address` acco on acco.id_tnt_account_address = reco.id_tnt_account_address
            where reco.booked  is null
            group by reco.id_tnt_account_address
        ");
        if (!$result) {
            return false;
        }
        return $result;
    }

    public function getBookingByIdAddress($id_address) {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
            select reco.id_order,reco.group_code,reco.total_weight,reco.reference, reco.connumber, tnt_acc.*,ctr.iso_code as company_country, sta.name as company_province
            from `" . _DB_PREFIX_ . "tnt_recogida_label` as reco
            inner join `" . _DB_PREFIX_ . "tnt_account_address` tnt_acc_add on tnt_acc_add.id_tnt_account_address = reco.id_tnt_account_address
            inner join `" . _DB_PREFIX_ . "tnt_account` tnt_acc on tnt_acc.id_tnt_account = tnt_acc_add.id_tnt_account
                left join `" . _DB_PREFIX_ . "country` ctr on ctr.id_country = tnt_acc.id_country
                left join `" . _DB_PREFIX_ . "state` sta on sta.id_country = ctr.id_country and sta.id_state = tnt_acc.id_state
            where reco.booked is null
            and reco.id_tnt_account_address = '" . $id_address . "'
        ");
        if (!$result) {
            return false;
        }
        return $result;
    }

    public function getByConnumber($connumber) {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
            select reco.*, tnt_acc.loginuser, tnt_acc.password
            from `" . _DB_PREFIX_ . "tnt_recogida_label` as reco
            inner join `" . _DB_PREFIX_ . "tnt_account_address` tnt_acc_add on tnt_acc_add.id_tnt_account_address = reco.id_tnt_account_address
            inner join `" . _DB_PREFIX_ . "tnt_account` tnt_acc on tnt_acc.id_tnt_account = tnt_acc_add.id_tnt_account
            where reco.connumber = '" . $connumber . "'
        ");
        if (!$result) {
            return false;
        }
        return $result[0];
    }

    public function getOrderByConnumber($connumber) {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS("
            select
            rec_lab.id_order,
            rec_lab.connumber,
            serv.code,
            serv.description,
            sta.name,
            ctr.iso_code,
            ord.id_order,
            ord.reference,
            ord.total_paid,
            cus.firstname,
            cus.lastname,
            cus.email,
            adr.address1,
            adr.address2,
            adr.postcode,
            adr.city,
            adr.phone,
            rec_lab.total_weight,
            rec_lab.total_volume,
            rec_lab.total_package,
            tnt_acc.loginuser,
            tnt_acc.password,
            tnt_acc_add.address as sender_addres,
            tnt_acc_add.postcode as sender_postcode,
            tnt_acc_add.city as sender_city,
            (select count(id_order_detail) from `" . _DB_PREFIX_ . "order_detail` where id_order = rec_lab.id_order) as total_item
            from `" . _DB_PREFIX_ . "tnt_recogida_label` as rec_lab
            inner join `" . _DB_PREFIX_ . "tnt_account_address` tnt_acc_add on tnt_acc_add.id_tnt_account_address = rec_lab.id_tnt_account_address
            inner join `" . _DB_PREFIX_ . "tnt_account` tnt_acc on tnt_acc.id_tnt_account = tnt_acc_add.id_tnt_account
            inner join `" . _DB_PREFIX_ . "tnt_service` serv on serv.id_tnt_service = rec_lab.id_tnt_service
            inner join `" . _DB_PREFIX_ . "orders` ord on ord.id_order = rec_lab.id_order
            inner join `" . _DB_PREFIX_ . "customer` cus on  ord.id_customer = cus.id_customer
            inner join `" . _DB_PREFIX_ . "address` adr on ord.id_address_delivery = adr.id_address
            left join `" . _DB_PREFIX_ . "country` ctr on ctr.id_country = adr.id_country
            left join `" . _DB_PREFIX_ . "state` sta on sta.id_country = ctr.id_country and sta.id_state = adr.id_state
            where rec_lab.connumber= '" . $connumber . "'
        ");




        if (!$result) {
            return false;
        }
        return $result[0];
    }

}
