<?php
/*
* 2007-2014 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Open Software License (OSL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/osl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2014 PrestaShop SA
*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/


class TntService extends ObjectModel
{
    public $code;
    public $description;
    public $document_type;
    public $national;
    public $division;

    /**
     * @see ObjectModel::$definition
     */
    public static $definition = array(
            'table' => 'tnt_service',
            'primary' => 'id_tnt_service',
            'fields' => array(
                    'code' =>	array('type' => self::TYPE_STRING, 'validate' => 'isGenericName', 'required' => true, 'size' => 64),
                    'description' =>	array('type' => self::TYPE_STRING, 'validate' => 'isGenericName', 'required' => true, 'size' => 64),
                    'document_type' =>	array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId', 'required' => false),
                    'national' =>	array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId', 'required' => false),
                    'division' =>	array('type' => self::TYPE_STRING, 'validate' => 'isGenericName', 'required' => true, 'size' => 64),
            ),
    );

    public static function getTntServiceNational()
    {
            $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
                        select nacional as id,
                           (CASE 
                                WHEN nacional = 0 THEN \'national\'
                                ELSE \'international\'
                            END) AS name
                        FROM `'._DB_PREFIX_.'tnt_service` 
                        group by name'); 
            
            return $result;
    }
    
    public static function getTntServiceOptions()
    {
            $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
                        select id_tnt_service as id_group,
                               description as description,
                            CONCAT (
                                (CASE 
                                    WHEN nacional = 1 THEN \'Nacional - \'
                                    ELSE \'Internacional - \'
                                 END),
                                \'[\',code, \'] \', description,\' - \', 
                                (CASE 
                                    WHEN document_type = 0 THEN \'No Document\'
                                    ELSE \'Document\'
                                 END)
                                ) as name
                        FROM `'._DB_PREFIX_.'tnt_service` 
                        order by id_group'); 
            
            return $result;
    }    

	public static function getTntService()
	{
		$tntservices = array();
                $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
                        select id_tnt_service,
                               (CASE 
                                WHEN nacional = 1 THEN \'Nacional\'
                                ELSE \'Internacional\'
                               END) as tipo,
                               CONCAT (
                                    \'[\',code, \'] \', description,\' - \', 
                                    (CASE 
                                    WHEN document_type = N THEN \'No Document\'
                                        ELSE \'Document\'
                                    END)) as name
                        FROM `'._DB_PREFIX_.'tnt_service`'); 
                
		foreach ($result as $row)
			$tntservices[$row['id_tnt_service']] = $row;
                
		return $tntservices;
	}  
        
	public static function getTntServiceLabels()
	{
		$tntservices = array();
                $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
                        select id_tnt_service,
                               CONCAT (
                                    (CASE 
                                    WHEN nacional = 0 THEN \'Nacional -- \'
                                        ELSE \'Internacional -- \'
                                    END),
                                    \'[\',code, \'] \', description,\' - \', 
                                    (CASE 
                                    WHEN document_type = \'N\' THEN \'No Document\'
                                        ELSE \'Document\'
                                    END)) as name
                        FROM `'._DB_PREFIX_.'tnt_service`'); 
                
		foreach ($result as $row)
			$tntservices[$row['id_tnt_service']] = $row;
                
		return $tntservices;
	}  
        
        public static function getAccountService($id_tnt_service)
	{
		$tntservices = array();
                $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
                        select id_tnt_service,
                               CONCAT (
                                    (CASE 
                                    WHEN nacional = 0 THEN \'Nacional -- \'
                                        ELSE \'Internacional -- \'
                                    END),
                                    \'[\',code, \'] \', description,\' - \', 
                                    (CASE 
                                    WHEN document_type = \'N\' THEN \'No Document\'
                                        ELSE \'Document\'
                                    END)) as name
                        FROM `'._DB_PREFIX_.'tnt_service`'
                        .'where id_tnt_service in ('.$id_tnt_service.')'
                        ); 
                
		foreach ($result as $row)
			$tntservices[$row['id_tnt_service']] = $row;
                
		return $tntservices;
	}  
        
        public static function getServiceById($id_service){
             $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS(''
                     . 'select code, document_type, division,CONCAT (
                                    (CASE 
                                    WHEN nacional = 0 THEN \'Nacional -- \'
                                        ELSE \'Internacional -- \'
                                    END),
                                    \'[\',code, \'] \', description,\' - \', 
                                    (CASE 
                                    WHEN document_type = \'N\' THEN \'No Document\'
                                        ELSE \'Document\'
                                    END)) as name, insurance '
                     . 'from  `'._DB_PREFIX_.'tnt_service` where id_tnt_service = ' . $id_service);
             
             return $result[0];
            
        }
}

