<?php

/*
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author PrestaShop SA <contact@prestashop.com>
 *  @copyright  2007-2014 PrestaShop SA
 *  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccount.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccountAddress.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntOption.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntService.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntConnect.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntRecogidaLabel.php';

class AdminTntAjaxController extends ModuleAdminController {

    public function __construct() {
        //JSon call
        if (Tools::getValue('id_account')) {
            $address = TntAccountAddress::getTntAddressForLabelForm(Tools::getValue('id_account'));
            
            $account = TntAccount::getTntAccountById(Tools::getValue('id_account'));
            $service = TntService::getAccountService($account[Tools::getValue('id_account')]['id_tnt_service']);
            
            echo Tools::jsonEncode(array('id_account' => Tools::getValue('id_account'), 'address' => $address, 'service'=>$service));
            die;
        }
        if (Tools::getValue('id_service')) {
            $option = TntOption::getTntOptionByServiceId(Tools::getValue('id_service'));
            echo Tools::jsonEncode(array('option' => $option,));
            die;
        }
        if (Tools::getValue('id_option_check')) {
            $option = TntOption::getTntOptionById(Tools::getValue('id_option_check'));
            echo Tools::jsonEncode(array('option' => $option[0]));
            die;
        }

        if ($id_order = Tools::getValue('price')) {
            $connect = new TntConnect();

            $order = TntRecogidaLabel::getDetailOrderById($id_order);
            $sendig_address = TntAccountAddress::getAddresById(Tools::getValue('address'));
            $sendig_address = $sendig_address[Tools::getValue('address')];

            $service = TntService::getServiceById(Tools::getValue('service'));
            
            $account = TntAccount::getTntAccountById(Tools::getValue('account'));
            $account = $account[Tools::getValue('account')];

            $result = $connect->setCompany($sendig_address['loginuser'])->setPassword($sendig_address['password'])
                    ->getPrice($sendig_address['city'], $sendig_address['postcode'], $sendig_address['company_country'], $order['city'], $order['postcode'], $order['order_country'], Tools::getValue('weight'), Tools::getValue('volume'), Tools::getValue('package'),$service,$account['account']);

            echo Tools::jsonEncode(array('price' => $result));
            die;
        }

        if ($id_order = Tools::getValue('price_by_id')) {
            $connect = new TntConnect();

            $order = TntRecogidaLabel::getOrderForPriceById($id_order);
            $order = $order[0];

            $result = $connect->setCompany($order['loginuser'])->setPassword($order['password'])
                    ->getPrice($order['sender_state'], $order['sender_postcode'], $order['sender_country'], $order['receiver_state'], $order['receiver_postcode'], $order['receiver_country'], $order['total_weight'], $order['total_volume'], $order['total_package'],$order,$order['account']);

            echo Tools::jsonEncode(array('price' => $result));
            die;
        }
        echo Tools::jsonEncode(array('true' => true));
        die;
    }

}
