<?php

/*
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author PrestaShop SA <contact@prestashop.com>
 *  @copyright  2007-2014 PrestaShop SA
 *  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */

include_once dirname(__FILE__) . '/../../classes/tnt/TntConnect.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccount.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntRecogidaLabel.php';

class AdminTntBookController extends ModuleAdminController {

    public function __construct() {

        parent::__construct();

        $this->_connect = new TntConnect();
        $this->_tntRecogidaLabel = new TntRecogidaLabel();
        $this->bootstrap = true;
    }

    public function initContent() {
        parent::initContent();
        $this->template = 'book.tpl';
        if (Tools::getValue('mensaje')) {
            $this->displayInformation($this->l('Se ha solicitado la recogida con éxito'));
        }

        if (Tools::getValue('id_address')) {

            $this->template = 'book_collect_time.tpl';
            $booking = $this->_tntRecogidaLabel->getBookingByIdAddress(Tools::getValue('id_address'));

            $template_cata = array(
                'booking' => $booking,
                'id_address' => Tools::getValue('id_address'),
                'title_collect_label' => $this->l('Hora de recogida'),
                'prefered_time_in' => $booking[0]['prefered_time_in'],
                'prefered_time_out' => $booking[0]['prefered_time_out'],
                'date_ini_label' => $this->l('Desde'),
                'date_end_label' => $this->l('Hasta'),
                'module_dir' => _MODULE_DIR_ . 'tntcarrier/',
                'collectinstruction_label' => $this->l('Instrucciones de Recogida'),
                'recoger' => $this->l('recoger'),
            );
            $this->context->smarty->assign($template_cata);


            if (Tools::getValue('date_ini') && Tools::getValue('date_end')) {
                foreach ($booking as $book) {
                    $connumber[] = $book['connumber'];
                }

                if ($this->_connect->makeCollectOrder(
                                $this->_connect
                                        ->setCompanyName($booking[0]['company_name'])
                                        ->setCompanyAddress1($booking[0]['company_address_1'])
                                        ->setCompanyAddress2($booking[0]['company_address_2'])
                                        ->setCompanyCity($booking[0]['company_city'])
                                        ->setCompanyProvince($booking[0]['company_province'])
                                        ->setCompanyPostcode($booking[0]['company_postcode'])
                                        ->setCompanyCountry($booking[0]['company_country'])
                                        ->setCompanyVat($booking[0]['company_vat'])
                                        ->setCompanyContactName($booking[0]['company_contact_name'])
                                        ->setCompanyContactDialCode($booking[0]['company_contact_dial_code'])
                                        ->setCompanyContactTelephone($booking[0]['company_contact_telephone'])
                                        ->setCompanyContactEmail($booking[0]['company_contact_email'])
                                        ->setCompany($booking[0]['loginuser'])
                                        ->setPassword($booking[0]['password'])
                                        ->setCollinstruction(Tools::getValue('collectinstruction'))
                                        ->setCollectTimeIn(Tools::getValue('date_ini'))
                                        ->setCollectTimeOut(Tools::getValue('date_end'))
                                        ->generateBook($connumber))
                ) {
                    foreach ($booking as $book) {
                        $this->_tntRecogidaLabel->updateBookedOrder($book['id_order'], $this->_connect->_booking_ref[$book['reference']]);
                    }
                    Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntBook') . '&mensaje=1');
                }
            }
        }


        $booking = $this->_tntRecogidaLabel->getBooking();

        $template_cata = array(
            'booking' => $booking,
            'solicitar_recogida_text' => $this->l('Solicitar recogida'),
            'weight_text' => $this->l('Total Kgs'),
            'group_code_text' => $this->l('Group Code'),
            'generate_text' => $this->l('Generar Manifiesto'),
            'address_text' => $this->l('Dirección de recogida'),
            'postal_code_text' => $this->l('Código Postal'),
            'city_text' => $this->l('Ciudad'),
            'no_booking_text' => $this->l('No hay envíos etiquetados'),
            'title_label' => $this->l('Recogidas'),
            'module_dir' => _MODULE_DIR_ . 'tntcarrier/',
        );
        $this->context->smarty->assign($template_cata);
    }

    public function setMedia() {

        $this->addJs(_MODULE_DIR_ . 'tntcarrier/views/js/tntcarrier.js');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/bootstrap.min.css');
        $this->addJqueryUI('ui.datepicker');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/tnt.css');
        parent::setMedia();
        parent::setMedia();
    }

}
