<?php

/*
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author PrestaShop SA <contact@prestashop.com>
 *  @copyright  2007-2014 PrestaShop SA
 *  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */

include_once dirname(__FILE__) . '/../../classes/tnt/TntConnect.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccount.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntRecogidaLabel.php';

class AdminTntManifestController extends ModuleAdminController {

    public function __construct() {

        parent::__construct();

        $this->_connect = new TntConnect();
        $this->_tntRecogidaLabel = new TntRecogidaLabel();
        $this->bootstrap = true;
    }

    public function initContent() {
        parent::initContent();
        $result = $this->_tntRecogidaLabel->getActiveManifest();




        if ($group_code = Tools::getValue('process')) {

            $this->_connect->setGroupCode($group_code);

            $orders = $this->_tntRecogidaLabel->getOrderByGroupCode($group_code);

            $account = TntAccount::getTntAccountById($orders[0]['id_tnt_account']);
            $account = $account[$orders[0]['id_tnt_account']];

            $this->_connect
                    ->setCompanyName($account['company_name'])
                    ->setCompanyAddress1($account['company_address_1'])
                    ->setCompanyAddress2($account['company_address_2'])
                    ->setCompanyAddress3($account['company_address_3'])
                    ->setCompanyCity($account['company_city'])
                    ->setCompanyProvince($account['company_province'])
                    ->setCompanyPostcode($account['company_postcode'])
                    ->setCompanyCountry($account['company_country'])
                    ->setCompanyVat($account['company_vat'])
                    ->setCompanyContactName($account['company_contact_name'])
                    ->setCompanyContactDialCode($account['company_contact_dial_code'])
                    ->setCompanyContactTelephone($account['company_contact_telephone'])
                    ->setCompanyContactEmail($account['company_contact_email'])
                    ->setCompany($account['loginuser'])
                    ->setAccount($account['account'])
                    ->setPassword($account['password'])
                    ->setSenderStreetAddres1($orders[0]['collect_addres_1'])
                    ->setSenderStreetAddres2($orders[0]['collect_addres_2'])
                    ->setSenderStreetAddres3($orders[0]['collect_addres_3'])
                    ->setSenderCity($orders[0]['collect_city'])
                    ->setSenderProvince($orders[0]['collect_state_name'])
                    ->setSenderPostCode($orders[0]['collect_postcode'])
                    ->setSenderCountry($orders[0]['collect_iso_code'])

            ;
            $this->_connect->setOrder($orders);
            $this->template = 'manifiesto.tpl';

            if ($manifest = $this->_connect->generateManifest(true)) {

                if (Tools::getValue('generate')) {
                    foreach ($orders as $order) {
                        $objOrder = new Order($order['id_order']); //order with id=1
                        $history = new OrderHistory();
                        $history->id_order = (int) $objOrder->id;
                        $id_order = (int) ($objOrder->id);
                        $history->changeIdOrderState(Configuration::get('TNT_ORDER_STATUS_SENDED'), $id_order);
			$history->addWithemail();
                    }
                    $this->_tntRecogidaLabel->updateManifestOrder($group_code);
                }
                echo "<script>
    var code_bar_url = '" . _MODULE_DIR_ . 'tntcarrier/img/barcode/' . "';
    </script>";
                echo $this->_connect->parse($this->_connect->generateManifest(true));
                echo $this->_connect->parse($this->_connect->generateManifest(true));
                echo $this->_connect->parse($this->_connect->generateManifest());
                echo "<script>
    window.print();
    </script>";
                die;
            } else {
                $template_cata = array(
                    'manifest' => $this->l('No se ha podido generar el manifiesto') . "<br />" . print_r($this->_connect->_error, true),
                );
            }
            $this->context->smarty->assign($template_cata);
        } elseif ($id_order = Tools::getValue('id_order')) {

            $orders = TntRecogidaLabel::getOrderById($id_order);

            $account = TntAccount::getTntAccountById($orders[0]['id_tnt_account']);
            $account = $account[$orders[0]['id_tnt_account']];


            $this->_connect
                    ->setCompanyName($account['company_name'])
                    ->setCompanyAddress1($account['company_address_1'])
                    ->setCompanyAddress2($account['company_address_2'])
                    ->setCompanyAddress3($account['company_address_3'])
                    ->setCompanyCity($account['company_city'])
                    ->setCompanyProvince($account['company_province'])
                    ->setCompanyPostcode($account['company_postcode'])
                    ->setCompanyCountry($account['company_country'])
                    ->setCompanyVat($account['company_vat'])
                    ->setCompanyContactName($account['company_contact_name'])
                    ->setCompanyContactDialCode($account['company_contact_dial_code'])
                    ->setCompanyContactTelephone($account['company_contact_telephone'])
                    ->setCompanyContactEmail($account['company_contact_email'])
                    ->setCompany($account['loginuser'])
                    ->setAccount($account['account'])
                    ->setPassword($account['password'])
                    ->setSenderStreetAddres1($orders[0]['collect_addres_1'])
                    ->setSenderStreetAddres2($orders[0]['collect_addres_2'])
                    ->setSenderStreetAddres3($orders[0]['collect_addres_3'])
                    ->setSenderCity($orders[0]['collect_city'])
                    ->setSenderProvince($orders[0]['collect_state_name'])
                    ->setSenderPostCode($orders[0]['collect_postcode'])
                    ->setSenderCountry($orders[0]['collect_iso_code'])
            ;

            $this->_connect->setOrder($orders);
            $this->template = 'manifiesto.tpl';

            if ($manifest = $this->_connect->generateManifest()) {

                echo "<script>
    var code_bar_url = '" . _MODULE_DIR_ . 'tntcarrier/img/barcode/' . "';
    </script>";
                echo $this->_connect->parse($this->_connect->generateManifest());
                echo "<script>
    window.print();
    </script>";
                die;
            } else {
                $template_cata = array(
                    'manifest' => $this->l('No se ha podido generar el manifiesto') . "<br />" . print_r($this->_connect->_error, true),
                );
            }
            $this->context->smarty->assign($template_cata);
        } else {


            $old = $this->_tntRecogidaLabel->getOldManifest(
                    Tools::getValue('filter_group_code'), Tools::getValue('filter_direccion_recogida'), Tools::getValue('filter_cod_postal'), Tools::getValue('filter_ciudad'), Tools::getValue('manifest_date_ini'), Tools::getValue('manifest_date_end')
            );

            $this->template = 'manifest_search.tpl';
            $template_cata = array(
                'manifest' => $result,
                'old_manifest' => $old,
                'old_manifest_text' => $this->l('Manifiestos anteriores'),
                'group_code_text' => $this->l('Group Code'),
                'generate_text' => $this->l('Generar Manifiesto'),
                'generated_text' => $this->l('Ver Manifiesto'),
                'generated_individual_text' => $this->l('Ver Manifiesto detallado'),
                'address_text' => $this->l('Dirección de recogida'),
                'postal_code_text' => $this->l('Código Postal'),
                'city_text' => $this->l('Ciudad'),
                'total_package_text' => $this->l('Ordenes totales en el manifiesto'),
                'manifest_date_text' => $this->l('Fecha manifiesto'),
                'manifest_date_ini_label' => $this->l('A partir de'),
                'manifest_date_end_label' => $this->l('Hasta'),
                'search_text' => $this->l('Buscar'),
                'search_warning_text' => $this->l('Eliminar filtros'),
                'manifest_pendiente_text' => $this->l('Manifiestos pendientes'),
                'manifest_historico_text' => $this->l('Histórico de Manifiestos'),
                'module_dir' => _MODULE_DIR_ . 'tntcarrier/',
            );
            $this->context->smarty->assign($template_cata);
        }
    }

    public function setMedia() {
        $this->addJs(_MODULE_DIR_ . 'tntcarrier/views/js/tntcarrier.js');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/bootstrap.min.css');
        $this->addJqueryUI('ui.datepicker');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/tnt.css');
        parent::setMedia();
    }

}
