<?php

include_once dirname(__FILE__) . '/../../classes/tnt/TntAccount.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntConnect.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntService.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntOrder.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntOption.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccountAddress.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntManifiesto.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntRecogidaLabel.php';

class AdminTntRecogidaController extends ModuleAdminController {

    public function __construct() {
        $this->bootstrap = true;
        $this->context = Context::getContext();
        $this->className = 'TntRecogida';
        $this->table = 'tnt_recogida';
        parent::__construct();
        $this->template = 'recogida.tpl';


        $this->_connect = new TntConnect();

        $this->_id_account = Tools::getValue('id_account');
        $this->_id_address = Tools::getValue('id_address');
        $this->_id_service = Tools::getValue('id_service');
        $this->_id_order = Tools::getValue('id_order');
        $this->_width = Tools::getValue('width');
        $this->_height = Tools::getValue('height');
        $this->_depth = Tools::getValue('depth');
        $this->_weight = Tools::getValue('weight');
        $this->_package = Tools::getValue('package');
        $this->_insurance = Tools::getValue('insurance');
        $this->_cod = Tools::getValue('cod');
        $this->_plr = Tools::getValue('plr');
        $this->_priority = Tools::getValue('priority');
        $this->_delivery_instruction = Tools::getValue('delivery_instruction');
    }

    public function conectar() {
        $account = TntAccount::getTntAccountById($this->_id_account);
        $address = TntAccountAddress::getAddresById($this->_id_address);
        $service = TntService::getServiceById($this->_id_service);
        $option = null;

        $producto = array();


        $this->_connect
                ->setCompanyName($account[$this->_id_account]['company_name'])
                ->setCompanyEmailNotification($account[$this->_id_account]['envio_email_cliente'])
                ->setCompanyAddress1($account[$this->_id_account]['company_address_1'])
                ->setCompanyAddress2($account[$this->_id_account]['company_address_2'])
                ->setCompanyAddress3($account[$this->_id_account]['company_address_3'])
                ->setCompanyCity($account[$this->_id_account]['company_city'])
                ->setCompanyProvince($account[$this->_id_account]['company_province'])
                ->setCompanyPostcode($account[$this->_id_account]['company_postcode'])
                ->setCompanyCountry($account[$this->_id_account]['company_country'])
                ->setCompanyVat($account[$this->_id_account]['company_vat'])
                ->setCompanyContactName($account[$this->_id_account]['company_contact_name'])
                ->setCompanyContactDialCode($account[$this->_id_account]['company_contact_dial_code'])
                ->setCompanyContactTelephone($account[$this->_id_account]['company_contact_telephone'])
                ->setCompanyContactEmail($account[$this->_id_account]['company_contact_email'])
                ->setCompany($account[$this->_id_account]['loginuser'])
                ->setAccount($account[$this->_id_account]['account'])
                ->setPassword($account[$this->_id_account]['password'])
                ->setSenderStreetAddres1($address[$this->_id_address]['address_1'])
                ->setSenderStreetAddres2($address[$this->_id_address]['address_2'])
                ->setSenderStreetAddres3($address[$this->_id_address]['address_3'])
                ->setSenderCity($address[$this->_id_address]['city'])
                ->setInsurance($this->_insurance)
                ->setCod($this->_cod)
                ->setPriority($this->_priority)
                ->setPlr($this->_plr)
                ->setSenderProvince($address[$this->_id_address]['company_province'])
                ->setDeliveryInstruction($this->_delivery_instruction)
                ->setSenderPostCode($address[$this->_id_address]['postcode'])
                ->setSenderCountry($address[$this->_id_address]['company_country'])
                ->setService($service['code'])
                ->setContentType($service['document_type'])
                ->setDivision($service['division'])
                ->setWidth($this->_width)
                ->setHeight($this->_height)
                ->setDepth($this->_depth)
                ->setWeight($this->_weight)
                ->setPackage($this->_package)
        //->setPedidos($productos);
        ;



        return true;
    }

    public function initContent() {
        parent::initContent();



        $account = TntAccount::getTntAccountById($this->_id_account);
        $address = TntAccountAddress::getAddresById($this->_id_address);



        $producto = array();



        $this->conectar();



        //$this->_connect->setGroupCode(null);
        $tntRecogida = new TntManifiesto();
        $tntRecogidaLabel = new TntRecogidaLabel();


        if ($code = $tntRecogidaLabel->getLastActive($this->_id_address)) {
            $this->_connect->setGroupCode($code['group_code']);
        }


        $order = TntAccountAddress::getProductoByPedidoId($this->_id_order);

        $this->_connect->setOrder($order);

        if ($this->_connect->getResult() && $this->_connect->getCreateResult('SUCCESS') == 'Y') {

            $tntRecogidaLabel->create(
                    $this->_id_order, $this->_id_service, $this->_id_address, (string) $this->_connect->getCreateResult('CONREF'), (string) $this->_connect->getCreateResult('CONNUMBER'), $this->_connect->getGroupCode(), $this->_connect->parse($this->_connect->getLabels()), $this->_connect->parse($this->_connect->getConsigment()), $this->_connect->_total_package, $this->_connect->_total_weight, $this->_connect->_total_volume, $this->_delivery_instruction
            );

            //Cambia estado pedido

            $objOrder = new Order($order['id_order']); //order with id=1
            $history = new OrderHistory();
            $history->id_order = (int) $objOrder->id;
            $id_order = (int) ($objOrder->id);
            $history->changeIdOrderState(Configuration::get('TNT_ORDER_STATUS_LABELED'), $id_order);
	    $history->addWithemail();

            // Actualizamos la orden de prestashop con el número de seguimiento de envío.
            TntOrder::setShippingNumber($id_order,(string) $this->_connect->getCreateResult('CONNUMBER'));
            
            
            Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntRequestLabel') . '&id_order=' . $order['id_order']);
        } else {
            $label[] = $this->l('Label no disponible');
            $label[] = print_r($this->_connect->_error, true);

            $file = $order['reference'] . '_' . $order['id_order'] . '_' . date('Ydm') . '.zip';
            $dir = dirname(__FILE__) . '/../../logs/';

            file_put_contents($dir . $file, $this->_connect->_xml_error);
        }

        $template_cata = array(
            'label' => $label,
            'xml_log_url' => _MODULE_DIR_ . 'tntcarrier/logs/' . $file,
            'error_log_label' => $this->l('Documento de error'),
        );
        $this->context->smarty->assign($template_cata);
    }

}
