<?php

/*
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author PrestaShop SA <contact@prestashop.com>
 *  @copyright  2007-2014 PrestaShop SA
 *  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccount.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntOption.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntService.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccountAddress.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntRecogidaLabel.php';

class AdminTntRequestLabelController extends ModuleAdminController {

    public function __construct() {
        $this->bootstrap = true;
        $this->context = Context::getContext();
        //$this->className = 'TntRequestLabel';
        $this->table = 'tnt_account';

        $this->template = 'form.tpl';

        if ($connumber = Tools::getValue('tracking')) {
            $label = new TntRecogidaLabel();
            $connect = new TntConnect();
            $result = $label->getByConnumber($connumber);

            $this->displayInformation($connect->setCompany($result['loginuser'])->setPassword($result['password'])->getTracking($connumber));
        }

        if (Tools::getValue('price')) {
            $label = new TntRecogidaLabel();
            $connect = new TntConnect();
            $result = $label->getDetailOrderById(Tools::getValue('id_order'));
        }


        parent::__construct();

        $account = TntAccount::getTntAccountForLabelForm();

        // Hecho así porque la clase devuelve el ID de la cuenta como key del array. No lo devuelve en order lógico.
        foreach ($account as $acc) {
            $primero = $acc['value'];
            break;
        }

        if (!Tools::getValue('id_order')) {
            Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntShippingList'));
        }


        $order = TntAccountAddress::getProductoByPedidoId(Tools::getValue('id_order'));

        if (!$order) {
            Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntShippingList'));
        }

        if ($order['connumber']) {
            $this->template = 'review_data.tpl';
            $account = TntAccountAddress::getAddresById($order['id_tnt_account_address']);
            $account = $account[$order['id_tnt_account_address']];

            $service = TntService::getServiceById($order['id_tnt_service']);
            echo "<script>
    var code_bar_url = '" . _MODULE_DIR_ . 'tntcarrier/img/barcode/' . "';
    </script>";
        } else {
            $service = TntService::getAccountService($account[$primero]['id_tnt_service']);
        }

        //Db::getInstance()->delete( _DB_PREFIX_ . 'tnt_recogida_label', 'id_order in (17922)');echo "listo";die;


        $template_cata = array(
            'title_send_label' => $this->l('Datos de envío'),
            'title_order_label' => $this->l('Información de compra'),
            'title_option_label' => $this->l('Servicios'),
            'order' => $order,
            'id_order' => Tools::getValue('id_order'),
            'total_paid' => $order['total_paid'],
            'account' => $account,
            'account_service_default' => isset($account[$primero]['id_tnt_service_default'])?$account[$primero]['id_tnt_service_default']:null,
            'address' => TntAccountAddress::getTntAddressForLabelForm($primero),
            'services' => $service,
            'option' => TntOption::getTntOption(),
            'default_values' => TntAccount::getDefaultValues(),
            'account_label' => $this->l('Cuenta TNT'),
            'address_label' => $this->l('Dirección de recogida'),
            'service_label' => $this->l('Servicio a contratar'),
            'width_label' => $this->l('Ancho'),
            'height_label' => $this->l('Alto'),
            'depth_label' => $this->l('Largo'),
            'track_text' => $this->l('Seguimiento'),
            'comentario_comprador' => $order['message'],
            'price_text' => $this->l('Precio'),
            'weight_label' => $this->l('Peso'),
            'package_label' => $this->l('Cantidad'),
            'total_volume_label' => $this->l('Volumen total'),
            'total_weight_label' => $this->l('Peso total'),
            'options_label' => $this->l('Opciones'),
            'cod_label' => $this->l('COD'),
            'insurance_label' => $this->l('Seguro'),
            'option_first_value_label' => $this->l('Seleccione opción'),
            'collinstruction_label' => $this->l('Instrucciones de recogida'),
            'instrucciones_especiales_text' => $this->l('Instrucciones especiales'),
            'module_dir' => _MODULE_DIR_ . 'tntcarrier/',
            'manifest' => $this->_generateManifest(Tools::getValue('id_order')),
            'etiquetas_label' => $this->l('Etiquetas'),
            'connote_label' => $this->l('Albarán'),
            'manifiesto_label' => $this->l('Manifiesto'),
            'referencia_label' => $this->l('Referencia'),
            'nombre_label' => $this->l('Nombre'),
            'email_label' => $this->l('Email'),
            'direccion_label' => $this->l('Dirección'),
            'ciudad_label' => $this->l('Ciudad'),
            'telefono_label' => $this->l('Teléfono'),
            'cod_label' => $this->l('COD'),
            'seguro_label' => $this->l('Seguro'),
            'prioridad_label' => $this->l('Prioridad'),
            'parking_list_return_label' => $this->l('Parking List Return'),
            'connumber_label' => $this->l('ConNumber'),
            'groupcode_label' => $this->l('Group Code'),
            'total_package_label' => $this->l('Total Bultos'),
            'total_weight_label' => $this->l('Peso Total'),
            'total_volume_label' => $this->l('Volumen Total'),
            'booking_label' => $this->l('Booking Number'),
            'seleccione_servicio_label' => $this->l('Seleccione servicio'),
            'guardar_label' => $this->l('Guardar'),
        );
        $this->context->smarty->assign($template_cata);

        //
    }

    public function postProcess() {
        $postData = array();
        $postData = $_POST;

        // TODO: Esto se pierde al cambiar hacer submit.
        $arrayOrders = Tools::getValue('order_id');

        if (count($postData) && is_numeric($_POST['service'])) {

            $id_account = Tools::getValue('account');
            $id_address = $_POST['address'];
            $id_service = $_POST['service'];
            $id_order = Tools::getValue('id_order');
            $width = Tools::getValue('width');
            $height = Tools::getValue('height');
            $depth = Tools::getValue('depth');
            $weight = Tools::getValue('weight');
            $package = Tools::getValue('package');
            $delivery_instruction = Tools::getValue('delivery_instruction');


            Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntRecogida') .
                    '&id_order=' . $id_order .
                    '&id_account=' . $id_account .
                    '&id_address=' . $id_address .
                    '&id_service=' . $id_service .
                    '&cod=' . Tools::getValue('cod') .
                    '&insurance=' . Tools::getValue('insurance') .
                    '&priority=' . Tools::getValue('priority') .
                    '&plr=' . Tools::getValue('plr') .
                    '&delivery_instruction=' . $delivery_instruction .
                    $this->generateUrlParam('width', Tools::getValue('width')) .
                    $this->generateUrlParam('height', Tools::getValue('height')) .
                    $this->generateUrlParam('depth', Tools::getValue('depth')) .
                    $this->generateUrlParam('weight', Tools::getValue('weight')) .
                    $this->generateUrlParam('package', Tools::getValue('package'))
            );
        }
    }

    private function generateUrlParam($name, $value) {
        $url = '';
        foreach ($value as $key => $val) {
            $url .= '&' . $name . '[' . $key . ']=' . $val;
        }
        return $url;
    }

    public function setMedia() {

        $this->addJs(_MODULE_DIR_ . 'tntcarrier/views/js/tntcarrier.js');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/bootstrap.min.css');
        $this->addJs('http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/tnt.css');
        parent::setMedia();
    }

    private function _generateManifest($id_order) {
        if ($orders = TntRecogidaLabel::getOrderById($id_order)) {

            $account = TntAccount::getTntAccountById($orders[0]['id_tnt_account']);
            $account = $account[$orders[0]['id_tnt_account']];
            $this->_connect = new TntConnect();

            $this->_connect
                    ->setCompanyName($account['company_name'])
                    ->setCompanyAddress1($account['company_address_1'])
                    ->setCompanyAddress2($account['company_address_2'])
                    ->setCompanyAddress3($account['company_address_3'])
                    ->setCompanyCity($account['company_city'])
                    ->setCompanyProvince($account['company_province'])
                    ->setCompanyPostcode($account['company_postcode'])
                    ->setCompanyCountry($account['company_country'])
                    ->setCompanyVat($account['company_vat'])
                    ->setCompanyContactName($account['company_contact_name'])
                    ->setCompanyContactDialCode($account['company_contact_dial_code'])
                    ->setCompanyContactTelephone($account['company_contact_telephone'])
                    ->setCompanyContactEmail($account['company_contact_email'])
                    ->setCompany($account['loginuser'])
                    ->setAccount($account['account'])
                    ->setPassword($account['password'])
                    ->setSenderStreetAddres1($orders[0]['collect_addres_1'])
                    ->setSenderStreetAddres2($orders[0]['collect_addres_2'])
                    ->setSenderStreetAddres3($orders[0]['collect_addres_3'])
                    ->setSenderCity($orders[0]['collect_city'])
                    ->setSenderProvince($orders[0]['collect_state_name'])
                    ->setSenderPostCode($orders[0]['collect_postcode'])
                    ->setSenderCountry($orders[0]['collect_iso_code'])
            ;

            $this->_connect->setOrder($orders);
            return $this->_connect->parse($this->_connect->generateManifest());
        } else {
            return false;
        }
    }

}
