<?php

/*
 * 2007-2014 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author PrestaShop SA <contact@prestashop.com>
 *  @copyright  2007-2014 PrestaShop SA
 *  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */
include_once dirname(__FILE__) . '/../../classes/tnt/TntRecogidaLabel.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntOrder.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntConnect.php';
include_once dirname(__FILE__) . '/../../classes/tnt/TntAccount.php';

class AdminTntShippinglistController extends ModuleAdminController {

    public $toolbar_title;
    protected $statuses_array = array();

    public function __construct() {


        $this->context = Context::getContext();
        $this->template = 'order_list.tpl';
        $this->bootstrap = true;




        parent::__construct();
    }

    public function initContent() {
        parent::initContent();
        $this->_order = new TntOrder();


        $order_state = (TntOrder::getOrderStates((int) Context::getContext()->language->id));




        
        $active = "id_order";
        $order_way = 'desc';
        $order_by = $active . ' ' . $order_way;
        if (Tools::getValue('order_by')) {
            $order_by = Tools::getValue('order_by') . " " . Tools::getValue('order_way');
            $active = Tools::getValue('order_by');
            $order_way = Tools::getValue('order_way');
            
        }

//print_r($_GET);die;

        $order = $this->_order->getOrder((int) $this->context->language->id, $order_by, Tools::getValue('filter_reference'), Tools::getValue('filter_status'), Tools::getValue('filter_manifested'), Tools::getValue('filter_connumber'), Tools::getValue('filter_booked'), Tools::getValue('manifest_date_ini'), Tools::getValue('manifest_date_end'), Tools::getValue('filter_client'));

        $statuses = OrderState::getOrderStates((int) $this->context->language->id);
        foreach ($statuses as $status) {
            $this->statuses_array[$status['id_order_state']] = $status['name'];
        }
        $filter = '&filter_reference=' . Tools::getValue('filter_reference') .'&filter_status=' . Tools::getValue('filter_status'). '&filter_manifested='
                .Tools::getValue('filter_manifested') .'&filter_connumber=' .Tools::getValue('filter_connumber') 
                . '&filter_booked=' .Tools::getValue('filter_booked').'&manifest_date_ini='.Tools::getValue('manifest_date_ini').
                '&manifest_date_end='.Tools::getValue('manifest_date_end') .'&filter_client='.Tools::getValue('filter_client');
        
        $template_cata = array(
            'filter' => $filter,
            'orders' => $order,
            'order_way' => $order_way,
            'order_by' => $active,
            'order_state' => $order_state,
            'id_order_text' => $this->l('Id order'),
            'reference_text' => $this->l('Número de referencia'),
            'client_text' => $this->l('Cliente'),
            'status_text' => $this->l('Estado'),
            'connumber_text' => $this->l('Connumber'),
            'manifested_text' => $this->l('Manifestado'),
            'booked_text' => $this->l('Recogido'),
            'services_text' => $this->l('Servicios'),
            'booked_text' => $this->l('Ref de recogida'),
            'detail_text' => $this->l('Detalles'),
            'url_label' => $this->context->link->getAdminLink('AdminTntRequestLabel'),
            'url_print' => $this->context->link->getAdminLink('AdminTntPrintables'),
            'search_text' => $this->l('Buscar'),
            'search_warning_text' => $this->l('Eliminar filtros'),
            'get_label_text' => $this->l('Solicitar etiqueta'),
            'label_text' => $this->l('Etiqueta'),
            'connote_text' => $this->l('Albarán'),
            'manifest_date_ini_label' => $this->l('A partir de'),
            'manifest_date_end_label' => $this->l('Hasta'),
            'manifest_text' => $this->l('Manifiesto'),
            'seleccione_text' => $this->l('Seleccione'),
            'module_dir' => _MODULE_DIR_ . 'tntcarrier/',
        );
        $this->context->smarty->assign($template_cata);
    }

    public function renderForm() {
        $tntRecogidaLabel = new TntRecogidaLabel();
        if (!$tntRecogidaLabel->getLabel(Tools::getValue('id_order'))) {
            Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntRequestLabel') . '&id_order=' . Tools::getValue('id_order'));
        } else {
            Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntPrintables') . '&id_order=' . Tools::getValue('id_order'));
        }
    }

    public function setMedia() {

        $this->addJs(_MODULE_DIR_ . 'tntcarrier/views/js/tntcarrier.js');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/bootstrap.min.css');
        $this->addJqueryUI('ui.datepicker');
        $this->addCss(_MODULE_DIR_ . 'tntcarrier/views/css/tnt.css');
        parent::setMedia();
    }

}
