<?php

if (!defined('_PS_VERSION_'))
    exit;

class Tntcarrier extends CarrierModule {

    const PREFIX = 'tnt_carrier';
    const NAME = 'TNT';
    const INSTALL_SQL_FILE = 'db.sql';

    private $_tabs = array(
        array(
            'className' => 'AdminTntAccount',
            'title' => 'TNT',
            'active' => 1,
            'children' => array(
                array(
                    'className' => 'AdminTntShippinglist',
                    'title' => 'Envíos',
                    'position' => 1,
                    'active' => 1,
                ),
                array(
                    'className' => 'AdminTntAjax',
                    //'className' => 'AdminTntLabels',
                    'title' => 'AjaxCalls',
                    'position' => 1,
                    'active' => 0,
                ),
                array(
                    'className' => 'AdminTntRequestLabel',
                    //'className' => 'AdminTntLabels',
                    'title' => 'Atributos',
                    'position' => 1,
                    'active' => 0,
                ),
                array(
                    'className' => 'AdminTntRecogida',
                    //'className' => 'AdminTntLabels',
                    'title' => 'Contacto',
                    'position' => 2,
                    'active' => 0,
                ),
                array(
                    'className' => 'AdminTntBook',
                    //'className' => 'AdminTntLabels',
                    'title' => 'Recogida',
                    'position' => 2,
                    'active' => 1,
                ),
                array(
                    'className' => 'AdminTntManifest',
                    //'className' => 'AdminTntLabels',
                    'title' => 'Manifiesto',
                    'position' => 3,
                    'active' => 1,
                ),
                array(
                    'className' => 'AdminTntPrintables',
                    //'className' => 'AdminTntLabels',
                    'title' => 'Etiqueta',
                    'position' => 1,
                    'active' => 0,
                ),
                array(
                    'className' => 'AdminTntAccount',
                    'title' => 'Administrar cuentas',
                    'position' => 4,
                    'active' => 1,
                ),
                array(
                    'className' => 'AdminTntAccountAddress',
                    'title' => 'Administrar direcciones',
                    'position' => 5,
                    'active' => 1,
                ),
            ),
        ),
    );

    public function __construct() {
        $this->name = 'tntcarrier';
        $this->tab = 'shipping_logistics';
        $this->version = '1.9.4';
        $this->author = 'TNT Express';
        $this->need_instance = 0;
        $this->bootstrap = true;
        parent::__construct();

        $this->displayName = $this->l('TNT (Addons)');
        $this->description = $this->l('TNT Express es una de las mayores compañías mundiales de distribución urgente. TNT entrega diariamente cerca  de 1 millón de envíos, desde documentos y paquetes, hasta piezas de carga paletizada.');
        $this->ps_versions_compliancy = array('min' => '1.5.0.16', 'max' => _PS_VERSION_);
    }

    private function _createDB() {

        $status = array(
            'TNT_ORDER_STATUS_NO_LABEL' => array('label' => $this->l('Solicitar etiqueta TNT'), 'color' => '#ff6600'),
            'TNT_ORDER_STATUS_LABELED' => array('label' => $this->l('Etiquetado TNT'), 'color' => '#1ba60f'),
            'TNT_ORDER_STATUS_SENDED' => array('label' => $this->l('Enviado TNT'), 'color' => '#333f48'),
        );


        foreach ($status as $constant => $label) {

            if (!Configuration::get($constant)) {
                // order status is not defined - check if, it exists in the table
                $rq = Db::getInstance()->getRow('
	SELECT `id_order_state` FROM `' . _DB_PREFIX_ . 'order_state_lang`
	WHERE id_lang = \'' . pSQL('1') . '\' AND  name = \'' . pSQL($label['label']) . '\'');

                if ($rq && isset($rq['id_order_state']) && intval($rq['id_order_state']) > 0) {
                    // order status exists in the table - define it.

                    Configuration::updateValue($constant, $rq['id_order_state']);
                } else {

                    // order status doesn't exist in the table
                    // insert it into the table and then define it.
                    Db::getInstance()->Execute('
		INSERT INTO `' . _DB_PREFIX_ . 'order_state` (`send_email`,`module_name`, `color`) VALUES(0,\'' . self::PREFIX . '\', \'' . $label['color'] . '\')');
                    $stateid = Db::getInstance()->Insert_ID();
                    foreach (Language::getLanguages(true) as $lang) {
                        Db::getInstance()->Execute('INSERT INTO `' . _DB_PREFIX_ . 'order_state_lang` (`id_order_state`, `id_lang`, `name`, `template`)
		VALUES(' . intval($stateid) . ', ' . $lang['id_lang'] . ', \'' . $label['label'] . '\',\'TNT\')');
                    }
                    Configuration::updateValue($constant, $stateid);
                }
            }
        }


        if (!file_exists(dirname(__FILE__) . '/' . self::INSTALL_SQL_FILE)) {
            return false;
        } else if (!$sql = file_get_contents(dirname(__FILE__) . '/' . self::INSTALL_SQL_FILE)) {
            return false;
        }
        $sql = str_replace(array('PREFIX_', 'ENGINE_TYPE'), array(_DB_PREFIX_, _MYSQL_ENGINE_), $sql);
        $sql = preg_split("/;\s*[\r\n]+/", trim($sql));

        foreach ($sql as $query) {
            try {
                Db::getInstance()->execute(trim($query));
            } catch (Exception $e) {
                continue;
            }
            //if (!Db::getInstance()->execute(trim($query))) {
            // return false;
            //}
        }
        return true;
    }

    public function install() {
        $this->_createDB();
        if (parent::install() && $this->registerHook('UpdateCarrier')) {


            //Creamos un objeto carrier 
            $carrier = new Carrier();
            $carrier->name = self::NAME;
            $carrier->active = TRUE;
            $carrier->deleted = 0;
            $carrier->shipping_handling = FALSE;
            $carrier->range_behavior = 0;
            $carrier->delay[Configuration::get('PS_LANG_DEFAULT')] = self::NAME;
            $carrier->shipping_external = TRUE;
            $carrier->is_module = TRUE;

            $carrier->max_height = 2;
            $carrier->max_depth = 2;
            $carrier->max_weight = 500;
            $carrier->max_width = 1;
            $carrier->external_module_name = $this->name;
            $carrier->need_range = TRUE;
            if ($carrier->add()) {
                $groups = Group::getGroups(true);
                foreach ($groups as $group) {
                    Db::getInstance()->autoExecute(_DB_PREFIX_ . 'carrier_group', array(
                        'id_carrier' => (int) $carrier->id,
                        'id_group' => (int) $group['id_group']
                            ), 'INSERT');
                }

                $rangePrice = new RangePrice();
                $rangePrice->id_carrier = $carrier->id;
                $rangePrice->delimiter1 = '0';
                $rangePrice->delimiter2 = '1000000';
                $rangePrice->add();

                $rangeWeight = new RangeWeight();
                $rangeWeight->id_carrier = $carrier->id;
                $rangeWeight->delimiter1 = '0';
                $rangeWeight->delimiter2 = '1000000';
                $rangeWeight->add();

                $zones = Zone::getZones(true);
                foreach ($zones as $z) {
                    Db::getInstance()->autoExecute(_DB_PREFIX_ . 'carrier_zone', array('id_carrier' => (int) $carrier->id, 'id_zone' => (int) $z['id_zone']), 'INSERT');
                    Db::getInstance()->autoExecuteWithNullValues(_DB_PREFIX_ . 'delivery', array('id_carrier' => $carrier->id, 'id_range_price' => (int) $rangePrice->id, 'id_range_weight' => NULL, 'id_zone' => (int) $z['id_zone'], 'price' => '0'), 'INSERT');
                    Db::getInstance()->autoExecuteWithNullValues(_DB_PREFIX_ . 'delivery', array('id_carrier' => $carrier->id, 'id_range_price' => NULL, 'id_range_weight' => (int) $rangeWeight->id, 'id_zone' => (int) $z['id_zone'], 'price' => '0'), 'INSERT');
                }


                if (!copy(dirname(__FILE__) . '/carrier.jpg', _PS_SHIP_IMG_DIR_ . '/' . (int) $carrier->id . '.jpg')) {
                    
                }
                Configuration::updateValue(self::PREFIX, $carrier->id);
                Configuration::updateValue(self::PREFIX . '_reference', $carrier->id);
            }
            $this->installTab();
            $this->_createDB();

            return true;
        }
        return false;
    }

    public function uninstall() {
        $this->uninstallTab();

        if (parent::uninstall()) {
            $this->uninstallTab();
            $tmp_carrier_id = Configuration::get(self::PREFIX);
            $carrier = new Carrier($tmp_carrier_id);
            $carrier->delete();
            Db::getInstance()->execute(
                    "drop table " . _DB_PREFIX_ . "tnt_rela_service_option;"
                    . "drop table " . _DB_PREFIX_ . "tnt_option;"
                    . "drop table " . _DB_PREFIX_ . "tnt_service;"
            );
            Configuration::deleteByName(self::PREFIX);
            return true;
        }
        return false;
    }

    public function installTab($tabs = null, $padre = 0) {


        if (!$tabs) {
            $tabs = $this->_tabs;
        }


        foreach ($tabs as $tab) {

            $tab_padre = new Tab();
            $tab_padre->active = $tab['active'];
            $tab_padre->class_name = $tab['className'];
            $tab_padre->name = array();
            foreach (Language::getLanguages(true) as $lang)
                $tab_padre->name[$lang['id_lang']] = $tab['title'];

            //$tab->id_parent = (int)Tab::getIdFromClassName('AdminDashboard');
            $tab_padre->id_parent = (int) $padre;
            $tab_padre->module = $this->name;
            $tab_padre->add();
            if ($tab['children']) {
                $this->installTab($tab['children'], $tab_padre->id);
            }
        }
        return true;
    }

    public function uninstallTab($tabs = null) {

        if (!$tabs) {
            $tabs = $this->_tabs;
        }


        foreach ($tabs as $tab) {

            $id_tab = (int) Tab::getIdFromClassName($tab['className']);

            if ($id_tab) {
                if ($tab['children']) {
                    $this->uninstallTab($tab['children']);
                }

                $tab_to = new Tab($id_tab);
                $tab_to->delete();
            }
        }


        return true;
    }

    public function getContent() {
        Tools::redirectAdmin($this->context->link->getAdminLink('AdminTntAccount'));
    }

    /*
     * Nota: Estos dos modulos son obligatorios
     */

    public function getOrderShippingCost($params, $shipping_cost) {

        return false;
    }

    public function getOrderShippingCostExternal($params) {
        return false;
    }

    public function hookUpdateCarrier($params) {
        $id_carrier_old = (int) ($params['id_carrier']);
        $id_carrier_new = (int) ($params['carrier']->id);
        if ($id_carrier_old == (int) (Configuration::get(self::PREFIX)))
            Configuration::updateValue(self::PREFIX, $id_carrier_new);
    }

}
